/////////////////////////////////////////////////////////////////////////////////////////
//                  _____   ____          _______   ____   ____   ____                 //
//                 |     | |    | |    |     |     |    | |    | |    |                //
//                 |_____/ |  __/ |    |     |     |____| |    | |____|                //
//                 |     | |  \   |    |     |     |      |    | |                     //
//                 |_____/ |   \  |____|     |     |      |____| |                     //
//                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////SYNTHE TRIPLE OSCILLATEUR//////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
// Utilise la librairie Mozzi: https://sensorium.github.io/Mozzi/                      //
// Le circuit:                                                                         //
// 3 potentiomètres (patte1 = 5V, patte2 = AnalogIn (0,1,2), patte3=GND).              //
// 3 boutons ou interrupteurs (patte1 = GND, patte2 = digitalIn(2,3,4).                //
// Sortie ligne ou HP: digital pin 9.                                                  //
// Pour un meilleur résultat, il est conseillé d'ajouter un petit circuit de filtrage. //
// Voir ici: https://sensorium.github.io/Mozzi/learn/output/                           //
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
// Téléverser le code:                                                                 //
// En haut de cette fenêtre, cliquez sur "Outils" puis "type de carte" pour choisir    //
// le modèle d'arduino utilisé (UNO par exemple).                                      //
// Puis, dans "Outils" puis "Port", choisissez le port USB sur lequel il est connecté. //
// Cliquez ensuite sur le bouton rond avec la flèche -> pour envoyer le programme      //
// dans la carte arduino.                                                              //
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
// Développé auprès des jeunes de l'Institut Médico Educatif R. Doisneau.              //
// Paris, 2019.                                                                        //
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
// Pour toute question:                                                                //
// mail@edouardsufrin.com                                                              //
/////////////////////////////////////////////////////////////////////////////////////////

//LES LIBRAIRIES
#include <MozziGuts.h>
#include <Oscil.h>
#include <tables/sin2048_int8.h>
//LES FORMES D'ONDES
Oscil <SIN2048_NUM_CELLS, AUDIO_RATE> aSinA(SIN2048_DATA);
Oscil <SIN2048_NUM_CELLS, AUDIO_RATE> aSinB(SIN2048_DATA);
Oscil <SIN2048_NUM_CELLS, AUDIO_RATE> aSinC(SIN2048_DATA);
//LES VARIABLES
byte gainA = 255;
byte gainB = 255;
byte gainC = 255;
int freqA;
int freqB;
int freqC;
int minfreq=25;

void setup() {
  pinMode(2, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  startMozzi();
  aSinA.setFreq(0);
  aSinB.setFreq(0);
  aSinC.setFreq(0);}

void updateControl() {
if (digitalRead(2) == LOW)
{freqA = minfreq + (mozziAnalogRead(0) / 10);}
else{freqA = 0;}
aSinA.setFreq(freqA); 
if (digitalRead(3) == LOW)
{freqB = minfreq + (mozziAnalogRead(1) / 10);}
else {freqB = 0;}
aSinB.setFreq(freqB); 
if (digitalRead(4) == LOW)
{freqC = minfreq + (mozziAnalogRead(2) / 10);}
else {freqC = 0;}
aSinC.setFreq(freqC);}

int updateAudio() 
{int aSig = aSinA.next() + aSinB.next() + aSinC.next();
  aSig = aSig / 3;
  return aSig;}

void loop() 
{audioHook();}
